/*
 * Copyright 2013 Victor Nazarov <asviraspossible@gmail.com>.
 */
package com.github.sviperll;

/**
 *
 * @author Victor Nazarov <asviraspossible@gmail.com>
 */
public class ConfigurableFunction<T, R> implements Function<T, R> {
    private final Function<T, R> function;
    public ConfigurableFunction(Function<T, R> function) {
        this.function = function;
    }

    @Override
    public R apply(T t) {
        return function.apply(t);
    }

    public <U> ConfigurableFunction<T, U> composeWith(Function<R, U> thatFunction) {
        return Functions.compose(this.function, thatFunction);
    }

    public ConfigurableFunction<T, R> passNullThrough() {
        return Functions.passNullThrough(function);
    }

    public ConfigurableFunction<T, R> throwOnNull() {
        return Functions.throwOnNull(function);
    }
}
